#include <Wire.h>
#include <SPI.h>
#include <nRF24L01.h>
#include <RF24.h>
#include <TimeLib.h>
#include <printf.h>
#include <TinyGPS++.h>
#include <SoftwareSerial.h>

static const int RXPin = 2, TXPin = 3;
static const uint32_t GPSBaud = 9600;
 
TinyGPSPlus gps;
 
SoftwareSerial ss(RXPin, TXPin);

double valore_mina;
double latitudine;
double longitudine;
unsigned char b[sizeof(double)];
RF24 radio(7, 8); // CE, CSN

const byte address[6] = "00001";
double myArray[30];
char secondo[8];
char terzo[8];
char quarto[8];


uint32_t timer;
double timer_reset, timer_testa;
uint8_t i2cData[14]; // Buffer for I2C data

void setup() {
  Serial.begin(115200);
  radio.begin();
  radio.openWritingPipe(address);
  radio.setPALevel(RF24_PA_MAX);
  ss.begin(GPSBaud);
  
  timer = micros();
  timer_reset = 0;
  timer_testa = 0;
}

void loop() {

  smartDelay(1000);
  valore_mina = random(1000)/double(1000);
  
  myArray[0] = now();
  myArray[1] = gps.location.lat();
  myArray[2] = gps.location.lng();
  myArray[3] = valore_mina;
  
  radio.write(&myArray, sizeof(myArray));

//printf_begin();
//radio.printDetails();

for(int i=0; i<4; i++){
  Serial.print(myArray[i]);
  Serial.print(',');
  }
Serial.println();
}



static void smartDelay(unsigned long ms)
{
  unsigned long start = millis();
  do 
  {
    while (ss.available())
      gps.encode(ss.read());
  } while (millis() - start < ms);
}
